ben (1.22) unstable; urgency=medium

  * Revert "Use Domainslib instead of Parmap for parallelism", because
    Lwt_process uses fork which is incompatible with domains

 -- Stéphane Glondu <glondu@debian.org>  Tue, 30 Jun 2026 00:55:36 +0200

ben (1.21) unstable; urgency=medium

  * Support is-in-testing pseudo-field with files origin (like projectb)
  * Use Domainslib instead of Parmap for parallelism
  * Use dh_ocamllibinstall
    - move templates to libben-ocaml
  * Try harder to locate templates when BEN_TEMPLATES_DIR is not set

 -- Stéphane Glondu <glondu@debian.org>  Thu, 21 May 2026 11:04:07 +0200

ben (1.20) unstable; urgency=medium

  * Capitalize field names when importing from projectb

 -- Stéphane Glondu <glondu@debian.org>  Thu, 14 May 2026 20:50:13 +0200

ben (1.19) unstable; urgency=medium

  * Fix parsing of multiarch qualifiers in dependencies

 -- Stéphane Glondu <glondu@debian.org>  Wed, 13 May 2026 13:32:19 +0200

ben (1.18) unstable; urgency=medium

  * Evaluate build-dependencies as on buildds: take first alternative of
    disjunctions, and assume no build profiles

 -- Stéphane Glondu <glondu@debian.org>  Wed, 13 May 2026 09:11:23 +0200

ben (1.17) unstable; urgency=medium

  * Transition scripts:
    - change layout of generated repo
    - prettier output in main Makefile
    - simplify rebuild logic (remove update phase)
    - add support for selective --no-arch-all
  * Take provides into account in dep graph computation
  * Bump Standards-Version to 4.7.4

 -- Stéphane Glondu <glondu@debian.org>  Sun, 26 Apr 2026 09:31:21 +0200

ben (1.16) unstable; urgency=medium

  * Migration scripts:
    - use yq instead of a Python script to preprocess excuses.yaml
  * Monitor:
    - fix typo in call to check_media_dir
  * Remove Priority from debian/control

 -- Stéphane Glondu <glondu@debian.org>  Mon, 30 Mar 2026 16:34:07 +0200

ben (1.15) unstable; urgency=medium

  * Add an option to ignore build-depends-indep (Closes: #1122238)
  * Transition scripts:
    - output missing packages graph in SVG format
    - add link to tracker in missing packages graph
    - add reason tooltip in missing packages graph
  * Bump Standards-Version to 4.7.3
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Tue, 06 Jan 2026 10:46:50 +0100

ben (1.14) unstable; urgency=medium

  * Ignore multi-arch specifiers in dependencies (Closes: #1121833)
  * Change in terminology: use "component" instead of "area"
  * Add possibility to automatically detect components and architectures;
    remove hard-coded values
  * Fix a bad interaction between Re and Parmap libraries that caused
    segfaults

 -- Stéphane Glondu <glondu@debian.org>  Mon, 08 Dec 2025 14:30:38 +0100

ben (1.13) unstable; urgency=medium

  * Remove armel from examples and default values

 -- Stéphane Glondu <glondu@debian.org>  Tue, 25 Nov 2025 16:20:01 +0100

ben (1.12) unstable; urgency=medium

  * Fix regression in "ben query -s" (Closes: #1117440)
  * Bump Standards-Version to 4.7.2

 -- Stéphane Glondu <glondu@debian.org>  Mon, 06 Oct 2025 08:37:11 +0200

ben (1.11) unstable; urgency=medium

  * Preserve field order and name case in "ben query"

 -- Stéphane Glondu <glondu@debian.org>  Tue, 30 Sep 2025 10:14:14 +0200

ben (1.10) unstable; urgency=medium

  * Add a custom template example (Closes: #1111165)
  * Remove mips64el from defaults and examples

 -- Stéphane Glondu <glondu@debian.org>  Thu, 21 Aug 2025 08:00:31 +0200

ben (1.9) unstable; urgency=medium

  * Bump ocamlformat version to 0.27.0
  * Preprocess excuses.yaml to a more structured JSON file

 -- Stéphane Glondu <glondu@debian.org>  Mon, 10 Feb 2025 11:20:21 +0100

ben (1.8) unstable; urgency=medium

  * examples/transition-scripts:
    - add support for BEN_REBUILD_TIME_REFERENCE
    - add support for BEN_REBUILD_FTBFS
    - generalize for backports
    - many other small fixes and tunings
  * Avoid version and build date ending up in automatically computed ABI
  * Bump Standards-Version to 4.7.0

 -- Stéphane Glondu <glondu@debian.org>  Fri, 24 Jan 2025 06:11:38 +0100

ben (1.7) unstable; urgency=medium

  * Do not hardcode /usr/lib/ocaml (Closes: #1078226)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 09 Aug 2024 03:04:07 +0200

ben (1.6) unstable; urgency=medium

  * examples/transition-scripts:
    - create a directory per source package in pool
    - examples/ocaml: add JSON generator for ci.debian.net

 -- Stéphane Glondu <glondu@debian.org>  Mon, 29 Jul 2024 13:42:06 +0200

ben (1.5) unstable; urgency=medium

  * Add build-{status,architecture} pseudo-headers (Closes: #763462)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 15 Jul 2024 15:31:54 +0200

ben (1.4) unstable; urgency=medium

  * Fix FTBFS (missing installed files)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 06 Jul 2024 20:54:01 +0200

ben (1.3) unstable; urgency=medium

  * Big refactoring
    - make all libraries wrapped
    - do no longer use benl_ prefix
    - move CLI-related stuff to ben_frontends
  * Use UTC date to improve reproducibility

 -- Stéphane Glondu <glondu@debian.org>  Sat, 06 Jul 2024 15:33:44 +0200

ben (1.2) unstable; urgency=medium

  * Switch build system to dune
  * examples/transition-scripts:
    - make them less OCaml-centric
    - move OCaml-specific stuff to its own directory
    - replace most of commands in README.md by make targets

 -- Stéphane Glondu <glondu@debian.org>  Sat, 06 Jul 2024 10:01:45 +0200

ben (1.1) unstable; urgency=medium

  * rebuild:
    - use SIGINT handler instead of running stop_command
    - print current state on SIGUSR1
    - set debugging level from command line
    - prefix each debugging line with local time
    - add support for dependency filtering to break cycles
  * examples/ocaml-transition-scripts:
    - create missing.txt in create-transition.sh
    - behave well when .reason files are missing
    - add rebuild filter in ocaml-transition-scripts

 -- Stéphane Glondu <glondu@debian.org>  Thu, 27 Jun 2024 07:43:59 +0200

ben (1.0) unstable; urgency=medium

  * rebuild: complete rewrite with more debugging possibilities
  * examples/ocaml-transition-scripts:
    - complete rewrite using sbuild (with unshare backend) instead of
      pbuilder (sudo is no longer required)
    - add support for BEN_REBUILD_CACHE
    - add support for documenting failing reasons (in .reason files)
    - generate a graph of missing packages

 -- Stéphane Glondu <glondu@debian.org>  Wed, 26 Jun 2024 10:11:45 +0200

ben (0.10.5) unstable; urgency=medium

  * Use uri instead of netstring and drop dependency on ocamlnet

 -- Stéphane Glondu <glondu@debian.org>  Sun, 16 Jun 2024 11:34:02 +0200

ben (0.10.4) unstable; urgency=medium

  [ Stéphane Glondu ]
  * rebuild: improve mutex handling
  * examples/migrate:
    - add debcheck_parallel to migrate functions
  * examples/ocaml-transition-scripts:
    - use "runuser -u" instead of "su -c"
  * Add riscv64 to default architectures and examples

  [ Adrian Bunk ]
  * Depend on xz-utils
  * tracker: Add --run-debcheck

 -- Stéphane Glondu <glondu@debian.org>  Fri, 14 Jun 2024 07:28:04 +0200

ben (0.10.3) unstable; urgency=medium

  * rebuild: wait for pending builds to complete before invoking update
  * ocaml-transition-scripts: add support for BEN_REBUILD_TIMELIMIT

 -- Stéphane Glondu <glondu@debian.org>  Tue, 19 Sep 2023 16:34:04 +0200

ben (0.10.2) unstable; urgency=medium

  * Remove edos-debcheck pseudo-field
  * Add non-free-firmware area to defaults and examples
  * Update architecture list in defaults and examples
    - remove mipsel and replace powerpc by ppc64el
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Mon, 28 Aug 2023 05:09:22 +0200

ben (0.10.1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Tracker: honour --archs flag (Closes: #1029398)

  [ Adrian Bunk ]
  * Download: change default compression to xz

 -- Stéphane Glondu <glondu@debian.org>  Mon, 23 Jan 2023 07:36:52 +0100

ben (0.10.0) unstable; urgency=medium

  [ Mehdi Dogguy ]
  * New homepage: https://debian.pages.debian.net/ben/

  [ Jochen Sprickerhof ]
  * Replace which by command -v

  [ Stéphane Glondu ]
  * More concise output in debcheck in migrate examples
  * Many changes in "ben rebuild"
    - add parallelization option (-j)
    - handle repo update inside ben, so that a shell loop is not needed
  * Add OCaml transition preparation scripts to examples

  [ Debian Janitor ]
  * Update standards version to 4.6.0, no changes needed.

 -- Stéphane Glondu <glondu@debian.org>  Sat, 22 Jan 2022 08:08:05 +0100

ben (0.9.2) unstable; urgency=medium

  * Set status filters via URL parameters (Closes: #876966)
  * Use Tyxml.Html.txt instead of Tyxml.Html.pcdata as the latter is deprecated
  * Avoid deleting lock file when it exists
  * Add <label> tags to make filters easier to toggle (Closes: #956005)

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2021 21:44:44 +0100

ben (0.9.1) unstable; urgency=medium

  * Migrate: first remove binaries of migrated packages
  * Tracker: support multiple output formats (Closes: #970744)
  * Drop dependency on libpcre-ocaml-dev
  * Bump debhelper compat level to 13
  * Bump Standards-Version to 4.5.0
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Sun, 27 Sep 2020 11:40:02 +0200

ben (0.9.0) unstable; urgency=medium

  * Add a new "migrate" frontend
  * More helpful message when a dependency cycle is detected by "rebuild"
  * Add version to footer of HTML pages generated by "monitor"
  * Update architecture lists

 -- Stéphane Glondu <glondu@debian.org>  Tue, 12 Nov 2019 14:15:09 +0100

ben (0.8.3) unstable; urgency=medium

  * Fix exact package name match (Closes: #870319, #841720)
  * Keep all fields when parsing for "query -s" (Closes: #907959)
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 30 Jul 2019 17:04:37 +0200

ben (0.8.2) unstable; urgency=medium

  * Fix typo in reference manual. Thanks to Paul Gevers for the
    patch.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 03 Jun 2018 14:08:45 +0200

ben (0.8.1) unstable; urgency=medium

  * Fix a minor typo in refman
  * Port to ocaml-re 1.7.2 and set 1.7.2 as minimal required version for
    ocaml-re in d/control
  * Add buildd and rcbug links for arch:all packages (Closes: #900627)
  * Raise a meaningful error when failing to parse a query
  * Add a visible tag for arch:all packages, as done for ma:same

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 03 Jun 2018 13:30:20 +0200

ben (0.8.0) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Activate most warnings and safe_string, and fix warnings
  * Add .mli files for frontends and remove dead code
  * Add a new "rebuild" frontend

  [ Mehdi Dogguy ]
  * Fix regexp in "ben query"
  * Add missing dependencies in META file
  * Insert automatically current version in META file
  * Migrate Git repository to Salsa
    - Update Vcs-* headers and documentation accordingly
  * Use asciidoctor instead of asciidoc (Closes: #895166)
  * Fix column layout for transitions divs in CSS (Closes: #873711).
    Thanks to Bas Couwenberg for the patch!
  * When verbose mode is set, warn if cache is being regenerated
  * Use new functions String.{lowercase,capitalize}_ascii instead of deprecated
    String.{lowercase,capitalize}
    - String.{capitalize,lowercase}_ascii need OCaml >= 4.03
  * Remove definitions of unused modules
  * Use long-option for curl for more clarity
  * Add more progress messages in "ben download"
  * Print path of downloaded and parsed files
  * When setting the cache_file, update cache_dir only when user supplies
    an absolute path
  * Add an ocamlbuild rule to build .cmxs files from .cmx (Closes: #876478)
    and document how to generate custom templates
  * Port to Tyxml 4.1
  * Use /usr/share/dpkg/pkg-info.mk instead of parsing changelog manually

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 21 May 2018 18:13:47 +0200

ben (0.7.7) unstable; urgency=medium

  * Use built-in ocamlfind support of ocamlbuild
  * Do not fail when "ocamlbuild -clean" fails

 -- Stéphane Glondu <glondu@debian.org>  Sun, 23 Jul 2017 17:19:31 +0200

ben (0.7.6) unstable; urgency=medium

  * Add ocamlbuild to Build-Depends

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jul 2017 23:22:09 +0200

ben (0.7.5) unstable; urgency=medium

  [ Mehdi Dogguy ]
  * Do not show the same warning about missing source packages multiple
    times
  * Do not output warnings about missing source packages in quiet mode

  [ James Clarke ]
  * Use deb.debian.org rather than httpredir.debian.org as the default
    mirror (Closes: #866341)
  * Use tracker.debian.org for PTS links (Closes: #866342)

  [ Stéphane Glondu ]
  * Take into account Build-Depends-Arch
  * Add Benl_parallel to benl.mllib
  * Bump debhelper compat to 10
  * Bump Standards-Version to 4.0.0
  * Update Vcs-*

 -- Stéphane Glondu <glondu@debian.org>  Fri, 21 Jul 2017 17:09:35 +0200

ben (0.7.4) unstable; urgency=medium

  * Set Section to ocaml for libben-ocaml{,-dev}
  * Show ignored architectures in italics in generated monitors.
  * Ignore failures of "dot" command during build (Closes: #815315).
  * Use https instead of http for external links (Closes: #810213).
  * Move libben-ocaml{,-dev} into OCaml section.
  * Use Bytes module instead of String where necessary.
  * Add a ticker in monitor for Partial state.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 19 Mar 2016 08:34:42 +0100

ben (0.7.3) unstable; urgency=medium

  * Port to tyxml 3.5
  * Tell curl to follow HTTP redirects

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 18 Oct 2015 16:07:27 +0200

ben (0.7.2) unstable; urgency=medium

  * Use date from last changelog entry in generated documentation to ensure
    a reproducible build.
  * Use http://httpredir.debian.org/debian as a default Debian mirror.
  * Update instructions in example file (Closes: #797100).
  * Set section to "devel" (Closes: #800390).
  * Drop Benl_arg module and use OCaml's Arg module. This change bumps
    minimal required version for OCaml to 4.01.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 18 Oct 2015 09:33:05 +0200

ben (0.7.1) unstable; urgency=medium

  [ Paul Wise ]
  * cdn.debian.net has been deprecated, replace it with http.debian.net

  [ Mehdi Dogguy ]
  * Ignore potential errors when deleting lock file
  * Use FileUtil.rm instead of calling /bin/rm
  * Replaces uses of Benl_core.list_iteri with List.iteri, which requires
    OCaml >= 4.0.
  * Call dose-debcheck with --deb-native-arch
  * Make build reproducible (Closes: #792054)
  * Add a note about order of command-line flags in documentation (Closes: #747875)
  * Add Json output format in monitor (Closes: #747883)
  * Drop --text, --xhtml and --color in favor of --output-format|-f

  [ Emilio Pozuelo Monfort ]
  * Fix buildd.debian.org compact links

  [ Simon McVittie ]
  * Add a new Partial category for packages that are both good and bad
    (Closes: #795314).

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 15 Aug 2015 00:17:37 +0000

ben (0.7.0) unstable; urgency=medium

  * Add --no-clean to "ben tracker" to leave unknown generated
    HTML files.
  * "ben tracker" will clean up the HTML directory by default from
    now on.
  * Add ability to read uncompressed files by specifying "plain",
    "no" or "none" as a compression format.
  * Remove --output-type from "ben tracker". Support for other output
    types didn't exist anyway and is not planned.
  * Simplify queries so that processing is, a bit, faster.
  * Make templates directory configurable through BEN_TEMPLATES_DIR
    environment variable.
  * Automatically set correct date and revision when generating refman.
  * Bump magic number to BENA0902 because of change in internal format
    of cache file. This requires regeneration of .cache files.
  * Ben should not define any of the modules exported by its library.
    Update the nodefined-map for Ben accordingly.
  * Add libocamlnet-ocaml-dev to Build-Depends, needed by Ben_monitor
    through usage of Netencoding (Closes: #750327).
  * Using -stdin, ben monitor will read its input file from the
    standard input (Closes: #747887).
  * Document how ben query makes the difference between Packages and
    Sources files (Closes: #747879).
  * Use Arg module to process CLI arguments.
  * Parallelize (using ParMap) ben's processing in all frontends, except
    query.
    - Add libparmap-ocaml-dev to Build-Depends.
  * Use Re.Pcre instead of Pcre in a few places to be able to parallelize
    since this requires serializing a few data structures.
  * Add a collision detector in ben tracker (Closes: #730619).
  * Read and show explanations given by dose-debcheck.
    - Add libextlib-ocaml-dev to Build-Depends.
  * Suppose no ignored architectures when ignored item is missing in
    the configuration file.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 25 Oct 2014 15:59:23 +0200

ben (0.6.10.1) unstable; urgency=medium

  * Fix built regexp to use for string matching.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 04 May 2014 09:31:23 +0200

ben (0.6.10) unstable; urgency=medium

  * Fix a bug in "ben query": Expand the list of kept field names
    using Benl_data.relevant_*_keys and Benl_clflags.more_relevant_*_keys
  * A little speed-up for queries on fixed strings (Closes: #732836).

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 04 May 2014 02:23:18 +0200

ben (0.6.9) unstable; urgency=medium

  * dose-debcheck package does not exist. Recommend dose-distcheck
    instead (Closes: #746507).

 -- Mehdi Dogguy <mehdi@debian.org>  Thu, 01 May 2014 13:20:10 +0200

ben (0.6.8) unstable; urgency=medium

  * Add --more-binary-keys and --more-binary-keys CLI options to be
    able to specify further relevant binary or source keys to consider
    when running `ben monitor`.
    This is a way to extend the default list of keys considered by Ben
    and which was introduced in 6f532423296083bed50b85a6ffb29b53e1349e23.
  * Remove ia64 from default list of architectures (Closes: #743724).
  * Translate to lowercase user-specified field names
  * Capitalize field names (and take into account a word separator) when
    printing them.
  * Add --preferred-compression-format (or -z) command line option to
    specify which compression algorithm to use. Known formats are Gzip,
    Bz2 and Xz. This automatically makes them known to "ben download"
    and "ben query".
  * Update architectures lists:
    - Remove sparc from Debian architectures.
    - Add HPPA in Debian Ports list.
  * Now cache-dir, cache-file and use-cache can be set in configuration
    files.
  * Read $HOME/.benrc file at startup and provide --no-benrc to skip it
    (Closes: #746046).

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 27 Apr 2014 23:12:15 +0200

ben (0.6.7) unstable; urgency=low

  [ Stéphane Glondu ]
  * In monitor, consider all binary packages of affected source packages
  * Sort transitions in tracker index (Closes: #732833)
  * Download .gz package lists instead of .bz2 (Closes: #736159)
  * Bump Standards-Version to 3.9.5

  [ Nobuhiro Iwamatsu ]
  * Update achitecture lists (Closes: #729090)

  [ Colin Watson ]
  * Tolerate templates with buildds or critical_bugs entries that return
    None (Closes: #728708)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 27 Jan 2014 11:26:46 +0100

ben (0.6.6) unstable; urgency=low

  * Simplify computation of dependency levels by using ocamlgraph's SCC
    module
  * Use uninstallable:yes instead of debcheck:uninstallable
  * Add back edos-debcheck pseudo-field for compatibility with the setup
    at release.debian.org
  * Update copyright information

 -- Stéphane Glondu <glondu@debian.org>  Sun, 18 Aug 2013 14:55:29 +0200

ben (0.6.5) unstable; urgency=low

  [ Stéphane Glondu ]
  * Upload to unstable
  * Migrate to dose-debcheck (Closes: #707599)
    - the pseudo-header "edos-debcheck" has been renamed into "debcheck";
      existing .ben files using it might need update
  * Add visual indication for sources that build "MA: same" binaries
    (Closes: #711908)
  * New computation of dependency levels, which should give better results
    when there are cycles or several connected components
  * Drop dependency to ocamlgraph (no longer used)
  * Update Vcs-*
  * Bump Standards-Version to 3.9.4 (no changes)

  [ Mehdi Dogguy ]
  * Fix changelog urls
  * Only warn instead of exiting when a .ben file is incorrect
  * Better error reporting wrt. configuration files
  * Separator between comparison operators and versions can be empty
  * Handle architecture restrictions in packages' relationships
  * Command-line flags --use-cache and --cache-file are now available
    for all frontends.

  [ Johannes Schauer ]
  * Allow creation of a cache in download (Closes: #714703)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 15 Aug 2013 23:57:07 +0200

ben (0.6.4) experimental; urgency=low

  * Pass -thread to ocamldoc when generating API documentation.
  * Pass needed flags to dh_ocaml so that Ben doesn't define modules
    Benl_error and Benl_templates.
  * Provide minimal documentation about HTML templates for Ben, and how
    to build them.

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 06 Jan 2013 16:28:59 +0100

ben (0.6.3) experimental; urgency=low

  * Fix a typo in Makefile which made the build system try a native
    build on architectures where dynlink.cmxa is not available.

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 08 Oct 2012 21:47:47 +0200

ben (0.6.2) experimental; urgency=low

  * Add missing dependency on curl. Thanks to Luca Falavigna for spotting
    it!
  * Make libjs-jquery a strong dependency and put a symlink in media
    (Closes: #680273)
  * Add docbook-xsl to Build-Depends (needed on Ubuntu to build the
    documentation). Thanks to Iain Lane!
  * Add a basic template mechanism
    - HTML templates are put under /usr/lib/ben/templates
    - Add --template command line option to "ben monitor" and "ben tracker"
    - Add "template" and "base-url" as configuration keys for "ben tracker"
  * The "media" directory is taken care by Ben directly now when "monitor"
    and "tracker" are used (See commit a5c222db6990da84ec30e4878d53bbda6).
  * Fix dependencies of the library in the META file.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 06 Oct 2012 22:46:05 +0200

ben (0.6.1) experimental; urgency=low

  [ Stéphane Glondu ]
  * Initial packaging

  [ Mehdi Dogguy ]
  * Initial Release (Closes: #679547)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 01 Jul 2012 22:10:36 +0200
